mod datagps;

#[cfg(test)]
mod tests {
    use crate::datagps::DataGPS;
    use crate::datagps::Bauds;

    #[test]
    fn set_baud_uart_test() {
        let mut data_gps = DataGPS::new(Bauds::Baud57600);
        let new_baud = Bauds::Baud9600;
        data_gps.set_baud_rate(&new_baud);
        assert_eq!(data_gps.get_baud_rate(),new_baud.get_value());
    }

    #[test]
    #[should_panic]
    fn uart_enabled(){
        let mut data_gps = DataGPS::new(Bauds::Baud57600);
        loop{
            data_gps.read_all_data();
        }
    }

    #[test]
    fn check_longitude(){
        let mut data_gps = DataGPS::new(Bauds::Baud9600);

        while data_gps.get_longitude().trim()=="No value"{
            data_gps.read_all_data()
        }
        let length = data_gps.get_longitude().len();
        let dir = data_gps.get_longitude().chars().nth(length-1).expect("Error").to_string();
        let long = data_gps.get_longitude();
        let x: Vec<&str> = long.split(".").collect();

        assert_eq!(x[0].to_owned()+&dir,"02155W")
    }
}